// Code generated by ent, DO NOT EDIT.

package item

import (
	"time"

	"entgo.io/ent/dialect/sql"
	"entgo.io/ent/dialect/sql/sqlgraph"
	"github.com/google/uuid"
	"github.com/mrusme/journalist/ent/predicate"
)

// ID filters vertices based on their ID field.
func ID(id uuid.UUID) predicate.Item {
	return predicate.Item(sql.FieldEQ(FieldID, id))
}

// IDEQ applies the EQ predicate on the ID field.
func IDEQ(id uuid.UUID) predicate.Item {
	return predicate.Item(sql.FieldEQ(FieldID, id))
}

// IDNEQ applies the NEQ predicate on the ID field.
func IDNEQ(id uuid.UUID) predicate.Item {
	return predicate.Item(sql.FieldNEQ(FieldID, id))
}

// IDIn applies the In predicate on the ID field.
func IDIn(ids ...uuid.UUID) predicate.Item {
	return predicate.Item(sql.FieldIn(FieldID, ids...))
}

// IDNotIn applies the NotIn predicate on the ID field.
func IDNotIn(ids ...uuid.UUID) predicate.Item {
	return predicate.Item(sql.FieldNotIn(FieldID, ids...))
}

// IDGT applies the GT predicate on the ID field.
func IDGT(id uuid.UUID) predicate.Item {
	return predicate.Item(sql.FieldGT(FieldID, id))
}

// IDGTE applies the GTE predicate on the ID field.
func IDGTE(id uuid.UUID) predicate.Item {
	return predicate.Item(sql.FieldGTE(FieldID, id))
}

// IDLT applies the LT predicate on the ID field.
func IDLT(id uuid.UUID) predicate.Item {
	return predicate.Item(sql.FieldLT(FieldID, id))
}

// IDLTE applies the LTE predicate on the ID field.
func IDLTE(id uuid.UUID) predicate.Item {
	return predicate.Item(sql.FieldLTE(FieldID, id))
}

// ItemGUID applies equality check predicate on the "item_guid" field. It's identical to ItemGUIDEQ.
func ItemGUID(v string) predicate.Item {
	return predicate.Item(sql.FieldEQ(FieldItemGUID, v))
}

// ItemTitle applies equality check predicate on the "item_title" field. It's identical to ItemTitleEQ.
func ItemTitle(v string) predicate.Item {
	return predicate.Item(sql.FieldEQ(FieldItemTitle, v))
}

// ItemDescription applies equality check predicate on the "item_description" field. It's identical to ItemDescriptionEQ.
func ItemDescription(v string) predicate.Item {
	return predicate.Item(sql.FieldEQ(FieldItemDescription, v))
}

// ItemContent applies equality check predicate on the "item_content" field. It's identical to ItemContentEQ.
func ItemContent(v string) predicate.Item {
	return predicate.Item(sql.FieldEQ(FieldItemContent, v))
}

// ItemLink applies equality check predicate on the "item_link" field. It's identical to ItemLinkEQ.
func ItemLink(v string) predicate.Item {
	return predicate.Item(sql.FieldEQ(FieldItemLink, v))
}

// ItemUpdated applies equality check predicate on the "item_updated" field. It's identical to ItemUpdatedEQ.
func ItemUpdated(v time.Time) predicate.Item {
	return predicate.Item(sql.FieldEQ(FieldItemUpdated, v))
}

// ItemPublished applies equality check predicate on the "item_published" field. It's identical to ItemPublishedEQ.
func ItemPublished(v time.Time) predicate.Item {
	return predicate.Item(sql.FieldEQ(FieldItemPublished, v))
}

// ItemAuthorName applies equality check predicate on the "item_author_name" field. It's identical to ItemAuthorNameEQ.
func ItemAuthorName(v string) predicate.Item {
	return predicate.Item(sql.FieldEQ(FieldItemAuthorName, v))
}

// ItemAuthorEmail applies equality check predicate on the "item_author_email" field. It's identical to ItemAuthorEmailEQ.
func ItemAuthorEmail(v string) predicate.Item {
	return predicate.Item(sql.FieldEQ(FieldItemAuthorEmail, v))
}

// ItemImageTitle applies equality check predicate on the "item_image_title" field. It's identical to ItemImageTitleEQ.
func ItemImageTitle(v string) predicate.Item {
	return predicate.Item(sql.FieldEQ(FieldItemImageTitle, v))
}

// ItemImageURL applies equality check predicate on the "item_image_url" field. It's identical to ItemImageURLEQ.
func ItemImageURL(v string) predicate.Item {
	return predicate.Item(sql.FieldEQ(FieldItemImageURL, v))
}

// ItemCategories applies equality check predicate on the "item_categories" field. It's identical to ItemCategoriesEQ.
func ItemCategories(v string) predicate.Item {
	return predicate.Item(sql.FieldEQ(FieldItemCategories, v))
}

// ItemEnclosures applies equality check predicate on the "item_enclosures" field. It's identical to ItemEnclosuresEQ.
func ItemEnclosures(v string) predicate.Item {
	return predicate.Item(sql.FieldEQ(FieldItemEnclosures, v))
}

// CrawlerTitle applies equality check predicate on the "crawler_title" field. It's identical to CrawlerTitleEQ.
func CrawlerTitle(v string) predicate.Item {
	return predicate.Item(sql.FieldEQ(FieldCrawlerTitle, v))
}

// CrawlerAuthor applies equality check predicate on the "crawler_author" field. It's identical to CrawlerAuthorEQ.
func CrawlerAuthor(v string) predicate.Item {
	return predicate.Item(sql.FieldEQ(FieldCrawlerAuthor, v))
}

// CrawlerExcerpt applies equality check predicate on the "crawler_excerpt" field. It's identical to CrawlerExcerptEQ.
func CrawlerExcerpt(v string) predicate.Item {
	return predicate.Item(sql.FieldEQ(FieldCrawlerExcerpt, v))
}

// CrawlerSiteName applies equality check predicate on the "crawler_site_name" field. It's identical to CrawlerSiteNameEQ.
func CrawlerSiteName(v string) predicate.Item {
	return predicate.Item(sql.FieldEQ(FieldCrawlerSiteName, v))
}

// CrawlerImage applies equality check predicate on the "crawler_image" field. It's identical to CrawlerImageEQ.
func CrawlerImage(v string) predicate.Item {
	return predicate.Item(sql.FieldEQ(FieldCrawlerImage, v))
}

// CrawlerContentHTML applies equality check predicate on the "crawler_content_html" field. It's identical to CrawlerContentHTMLEQ.
func CrawlerContentHTML(v string) predicate.Item {
	return predicate.Item(sql.FieldEQ(FieldCrawlerContentHTML, v))
}

// CrawlerContentText applies equality check predicate on the "crawler_content_text" field. It's identical to CrawlerContentTextEQ.
func CrawlerContentText(v string) predicate.Item {
	return predicate.Item(sql.FieldEQ(FieldCrawlerContentText, v))
}

// CreatedAt applies equality check predicate on the "created_at" field. It's identical to CreatedAtEQ.
func CreatedAt(v time.Time) predicate.Item {
	return predicate.Item(sql.FieldEQ(FieldCreatedAt, v))
}

// UpdatedAt applies equality check predicate on the "updated_at" field. It's identical to UpdatedAtEQ.
func UpdatedAt(v time.Time) predicate.Item {
	return predicate.Item(sql.FieldEQ(FieldUpdatedAt, v))
}

// ItemGUIDEQ applies the EQ predicate on the "item_guid" field.
func ItemGUIDEQ(v string) predicate.Item {
	return predicate.Item(sql.FieldEQ(FieldItemGUID, v))
}

// ItemGUIDNEQ applies the NEQ predicate on the "item_guid" field.
func ItemGUIDNEQ(v string) predicate.Item {
	return predicate.Item(sql.FieldNEQ(FieldItemGUID, v))
}

// ItemGUIDIn applies the In predicate on the "item_guid" field.
func ItemGUIDIn(vs ...string) predicate.Item {
	return predicate.Item(sql.FieldIn(FieldItemGUID, vs...))
}

// ItemGUIDNotIn applies the NotIn predicate on the "item_guid" field.
func ItemGUIDNotIn(vs ...string) predicate.Item {
	return predicate.Item(sql.FieldNotIn(FieldItemGUID, vs...))
}

// ItemGUIDGT applies the GT predicate on the "item_guid" field.
func ItemGUIDGT(v string) predicate.Item {
	return predicate.Item(sql.FieldGT(FieldItemGUID, v))
}

// ItemGUIDGTE applies the GTE predicate on the "item_guid" field.
func ItemGUIDGTE(v string) predicate.Item {
	return predicate.Item(sql.FieldGTE(FieldItemGUID, v))
}

// ItemGUIDLT applies the LT predicate on the "item_guid" field.
func ItemGUIDLT(v string) predicate.Item {
	return predicate.Item(sql.FieldLT(FieldItemGUID, v))
}

// ItemGUIDLTE applies the LTE predicate on the "item_guid" field.
func ItemGUIDLTE(v string) predicate.Item {
	return predicate.Item(sql.FieldLTE(FieldItemGUID, v))
}

// ItemGUIDContains applies the Contains predicate on the "item_guid" field.
func ItemGUIDContains(v string) predicate.Item {
	return predicate.Item(sql.FieldContains(FieldItemGUID, v))
}

// ItemGUIDHasPrefix applies the HasPrefix predicate on the "item_guid" field.
func ItemGUIDHasPrefix(v string) predicate.Item {
	return predicate.Item(sql.FieldHasPrefix(FieldItemGUID, v))
}

// ItemGUIDHasSuffix applies the HasSuffix predicate on the "item_guid" field.
func ItemGUIDHasSuffix(v string) predicate.Item {
	return predicate.Item(sql.FieldHasSuffix(FieldItemGUID, v))
}

// ItemGUIDEqualFold applies the EqualFold predicate on the "item_guid" field.
func ItemGUIDEqualFold(v string) predicate.Item {
	return predicate.Item(sql.FieldEqualFold(FieldItemGUID, v))
}

// ItemGUIDContainsFold applies the ContainsFold predicate on the "item_guid" field.
func ItemGUIDContainsFold(v string) predicate.Item {
	return predicate.Item(sql.FieldContainsFold(FieldItemGUID, v))
}

// ItemTitleEQ applies the EQ predicate on the "item_title" field.
func ItemTitleEQ(v string) predicate.Item {
	return predicate.Item(sql.FieldEQ(FieldItemTitle, v))
}

// ItemTitleNEQ applies the NEQ predicate on the "item_title" field.
func ItemTitleNEQ(v string) predicate.Item {
	return predicate.Item(sql.FieldNEQ(FieldItemTitle, v))
}

// ItemTitleIn applies the In predicate on the "item_title" field.
func ItemTitleIn(vs ...string) predicate.Item {
	return predicate.Item(sql.FieldIn(FieldItemTitle, vs...))
}

// ItemTitleNotIn applies the NotIn predicate on the "item_title" field.
func ItemTitleNotIn(vs ...string) predicate.Item {
	return predicate.Item(sql.FieldNotIn(FieldItemTitle, vs...))
}

// ItemTitleGT applies the GT predicate on the "item_title" field.
func ItemTitleGT(v string) predicate.Item {
	return predicate.Item(sql.FieldGT(FieldItemTitle, v))
}

// ItemTitleGTE applies the GTE predicate on the "item_title" field.
func ItemTitleGTE(v string) predicate.Item {
	return predicate.Item(sql.FieldGTE(FieldItemTitle, v))
}

// ItemTitleLT applies the LT predicate on the "item_title" field.
func ItemTitleLT(v string) predicate.Item {
	return predicate.Item(sql.FieldLT(FieldItemTitle, v))
}

// ItemTitleLTE applies the LTE predicate on the "item_title" field.
func ItemTitleLTE(v string) predicate.Item {
	return predicate.Item(sql.FieldLTE(FieldItemTitle, v))
}

// ItemTitleContains applies the Contains predicate on the "item_title" field.
func ItemTitleContains(v string) predicate.Item {
	return predicate.Item(sql.FieldContains(FieldItemTitle, v))
}

// ItemTitleHasPrefix applies the HasPrefix predicate on the "item_title" field.
func ItemTitleHasPrefix(v string) predicate.Item {
	return predicate.Item(sql.FieldHasPrefix(FieldItemTitle, v))
}

// ItemTitleHasSuffix applies the HasSuffix predicate on the "item_title" field.
func ItemTitleHasSuffix(v string) predicate.Item {
	return predicate.Item(sql.FieldHasSuffix(FieldItemTitle, v))
}

// ItemTitleEqualFold applies the EqualFold predicate on the "item_title" field.
func ItemTitleEqualFold(v string) predicate.Item {
	return predicate.Item(sql.FieldEqualFold(FieldItemTitle, v))
}

// ItemTitleContainsFold applies the ContainsFold predicate on the "item_title" field.
func ItemTitleContainsFold(v string) predicate.Item {
	return predicate.Item(sql.FieldContainsFold(FieldItemTitle, v))
}

// ItemDescriptionEQ applies the EQ predicate on the "item_description" field.
func ItemDescriptionEQ(v string) predicate.Item {
	return predicate.Item(sql.FieldEQ(FieldItemDescription, v))
}

// ItemDescriptionNEQ applies the NEQ predicate on the "item_description" field.
func ItemDescriptionNEQ(v string) predicate.Item {
	return predicate.Item(sql.FieldNEQ(FieldItemDescription, v))
}

// ItemDescriptionIn applies the In predicate on the "item_description" field.
func ItemDescriptionIn(vs ...string) predicate.Item {
	return predicate.Item(sql.FieldIn(FieldItemDescription, vs...))
}

// ItemDescriptionNotIn applies the NotIn predicate on the "item_description" field.
func ItemDescriptionNotIn(vs ...string) predicate.Item {
	return predicate.Item(sql.FieldNotIn(FieldItemDescription, vs...))
}

// ItemDescriptionGT applies the GT predicate on the "item_description" field.
func ItemDescriptionGT(v string) predicate.Item {
	return predicate.Item(sql.FieldGT(FieldItemDescription, v))
}

// ItemDescriptionGTE applies the GTE predicate on the "item_description" field.
func ItemDescriptionGTE(v string) predicate.Item {
	return predicate.Item(sql.FieldGTE(FieldItemDescription, v))
}

// ItemDescriptionLT applies the LT predicate on the "item_description" field.
func ItemDescriptionLT(v string) predicate.Item {
	return predicate.Item(sql.FieldLT(FieldItemDescription, v))
}

// ItemDescriptionLTE applies the LTE predicate on the "item_description" field.
func ItemDescriptionLTE(v string) predicate.Item {
	return predicate.Item(sql.FieldLTE(FieldItemDescription, v))
}

// ItemDescriptionContains applies the Contains predicate on the "item_description" field.
func ItemDescriptionContains(v string) predicate.Item {
	return predicate.Item(sql.FieldContains(FieldItemDescription, v))
}

// ItemDescriptionHasPrefix applies the HasPrefix predicate on the "item_description" field.
func ItemDescriptionHasPrefix(v string) predicate.Item {
	return predicate.Item(sql.FieldHasPrefix(FieldItemDescription, v))
}

// ItemDescriptionHasSuffix applies the HasSuffix predicate on the "item_description" field.
func ItemDescriptionHasSuffix(v string) predicate.Item {
	return predicate.Item(sql.FieldHasSuffix(FieldItemDescription, v))
}

// ItemDescriptionEqualFold applies the EqualFold predicate on the "item_description" field.
func ItemDescriptionEqualFold(v string) predicate.Item {
	return predicate.Item(sql.FieldEqualFold(FieldItemDescription, v))
}

// ItemDescriptionContainsFold applies the ContainsFold predicate on the "item_description" field.
func ItemDescriptionContainsFold(v string) predicate.Item {
	return predicate.Item(sql.FieldContainsFold(FieldItemDescription, v))
}

// ItemContentEQ applies the EQ predicate on the "item_content" field.
func ItemContentEQ(v string) predicate.Item {
	return predicate.Item(sql.FieldEQ(FieldItemContent, v))
}

// ItemContentNEQ applies the NEQ predicate on the "item_content" field.
func ItemContentNEQ(v string) predicate.Item {
	return predicate.Item(sql.FieldNEQ(FieldItemContent, v))
}

// ItemContentIn applies the In predicate on the "item_content" field.
func ItemContentIn(vs ...string) predicate.Item {
	return predicate.Item(sql.FieldIn(FieldItemContent, vs...))
}

// ItemContentNotIn applies the NotIn predicate on the "item_content" field.
func ItemContentNotIn(vs ...string) predicate.Item {
	return predicate.Item(sql.FieldNotIn(FieldItemContent, vs...))
}

// ItemContentGT applies the GT predicate on the "item_content" field.
func ItemContentGT(v string) predicate.Item {
	return predicate.Item(sql.FieldGT(FieldItemContent, v))
}

// ItemContentGTE applies the GTE predicate on the "item_content" field.
func ItemContentGTE(v string) predicate.Item {
	return predicate.Item(sql.FieldGTE(FieldItemContent, v))
}

// ItemContentLT applies the LT predicate on the "item_content" field.
func ItemContentLT(v string) predicate.Item {
	return predicate.Item(sql.FieldLT(FieldItemContent, v))
}

// ItemContentLTE applies the LTE predicate on the "item_content" field.
func ItemContentLTE(v string) predicate.Item {
	return predicate.Item(sql.FieldLTE(FieldItemContent, v))
}

// ItemContentContains applies the Contains predicate on the "item_content" field.
func ItemContentContains(v string) predicate.Item {
	return predicate.Item(sql.FieldContains(FieldItemContent, v))
}

// ItemContentHasPrefix applies the HasPrefix predicate on the "item_content" field.
func ItemContentHasPrefix(v string) predicate.Item {
	return predicate.Item(sql.FieldHasPrefix(FieldItemContent, v))
}

// ItemContentHasSuffix applies the HasSuffix predicate on the "item_content" field.
func ItemContentHasSuffix(v string) predicate.Item {
	return predicate.Item(sql.FieldHasSuffix(FieldItemContent, v))
}

// ItemContentEqualFold applies the EqualFold predicate on the "item_content" field.
func ItemContentEqualFold(v string) predicate.Item {
	return predicate.Item(sql.FieldEqualFold(FieldItemContent, v))
}

// ItemContentContainsFold applies the ContainsFold predicate on the "item_content" field.
func ItemContentContainsFold(v string) predicate.Item {
	return predicate.Item(sql.FieldContainsFold(FieldItemContent, v))
}

// ItemLinkEQ applies the EQ predicate on the "item_link" field.
func ItemLinkEQ(v string) predicate.Item {
	return predicate.Item(sql.FieldEQ(FieldItemLink, v))
}

// ItemLinkNEQ applies the NEQ predicate on the "item_link" field.
func ItemLinkNEQ(v string) predicate.Item {
	return predicate.Item(sql.FieldNEQ(FieldItemLink, v))
}

// ItemLinkIn applies the In predicate on the "item_link" field.
func ItemLinkIn(vs ...string) predicate.Item {
	return predicate.Item(sql.FieldIn(FieldItemLink, vs...))
}

// ItemLinkNotIn applies the NotIn predicate on the "item_link" field.
func ItemLinkNotIn(vs ...string) predicate.Item {
	return predicate.Item(sql.FieldNotIn(FieldItemLink, vs...))
}

// ItemLinkGT applies the GT predicate on the "item_link" field.
func ItemLinkGT(v string) predicate.Item {
	return predicate.Item(sql.FieldGT(FieldItemLink, v))
}

// ItemLinkGTE applies the GTE predicate on the "item_link" field.
func ItemLinkGTE(v string) predicate.Item {
	return predicate.Item(sql.FieldGTE(FieldItemLink, v))
}

// ItemLinkLT applies the LT predicate on the "item_link" field.
func ItemLinkLT(v string) predicate.Item {
	return predicate.Item(sql.FieldLT(FieldItemLink, v))
}

// ItemLinkLTE applies the LTE predicate on the "item_link" field.
func ItemLinkLTE(v string) predicate.Item {
	return predicate.Item(sql.FieldLTE(FieldItemLink, v))
}

// ItemLinkContains applies the Contains predicate on the "item_link" field.
func ItemLinkContains(v string) predicate.Item {
	return predicate.Item(sql.FieldContains(FieldItemLink, v))
}

// ItemLinkHasPrefix applies the HasPrefix predicate on the "item_link" field.
func ItemLinkHasPrefix(v string) predicate.Item {
	return predicate.Item(sql.FieldHasPrefix(FieldItemLink, v))
}

// ItemLinkHasSuffix applies the HasSuffix predicate on the "item_link" field.
func ItemLinkHasSuffix(v string) predicate.Item {
	return predicate.Item(sql.FieldHasSuffix(FieldItemLink, v))
}

// ItemLinkEqualFold applies the EqualFold predicate on the "item_link" field.
func ItemLinkEqualFold(v string) predicate.Item {
	return predicate.Item(sql.FieldEqualFold(FieldItemLink, v))
}

// ItemLinkContainsFold applies the ContainsFold predicate on the "item_link" field.
func ItemLinkContainsFold(v string) predicate.Item {
	return predicate.Item(sql.FieldContainsFold(FieldItemLink, v))
}

// ItemUpdatedEQ applies the EQ predicate on the "item_updated" field.
func ItemUpdatedEQ(v time.Time) predicate.Item {
	return predicate.Item(sql.FieldEQ(FieldItemUpdated, v))
}

// ItemUpdatedNEQ applies the NEQ predicate on the "item_updated" field.
func ItemUpdatedNEQ(v time.Time) predicate.Item {
	return predicate.Item(sql.FieldNEQ(FieldItemUpdated, v))
}

// ItemUpdatedIn applies the In predicate on the "item_updated" field.
func ItemUpdatedIn(vs ...time.Time) predicate.Item {
	return predicate.Item(sql.FieldIn(FieldItemUpdated, vs...))
}

// ItemUpdatedNotIn applies the NotIn predicate on the "item_updated" field.
func ItemUpdatedNotIn(vs ...time.Time) predicate.Item {
	return predicate.Item(sql.FieldNotIn(FieldItemUpdated, vs...))
}

// ItemUpdatedGT applies the GT predicate on the "item_updated" field.
func ItemUpdatedGT(v time.Time) predicate.Item {
	return predicate.Item(sql.FieldGT(FieldItemUpdated, v))
}

// ItemUpdatedGTE applies the GTE predicate on the "item_updated" field.
func ItemUpdatedGTE(v time.Time) predicate.Item {
	return predicate.Item(sql.FieldGTE(FieldItemUpdated, v))
}

// ItemUpdatedLT applies the LT predicate on the "item_updated" field.
func ItemUpdatedLT(v time.Time) predicate.Item {
	return predicate.Item(sql.FieldLT(FieldItemUpdated, v))
}

// ItemUpdatedLTE applies the LTE predicate on the "item_updated" field.
func ItemUpdatedLTE(v time.Time) predicate.Item {
	return predicate.Item(sql.FieldLTE(FieldItemUpdated, v))
}

// ItemPublishedEQ applies the EQ predicate on the "item_published" field.
func ItemPublishedEQ(v time.Time) predicate.Item {
	return predicate.Item(sql.FieldEQ(FieldItemPublished, v))
}

// ItemPublishedNEQ applies the NEQ predicate on the "item_published" field.
func ItemPublishedNEQ(v time.Time) predicate.Item {
	return predicate.Item(sql.FieldNEQ(FieldItemPublished, v))
}

// ItemPublishedIn applies the In predicate on the "item_published" field.
func ItemPublishedIn(vs ...time.Time) predicate.Item {
	return predicate.Item(sql.FieldIn(FieldItemPublished, vs...))
}

// ItemPublishedNotIn applies the NotIn predicate on the "item_published" field.
func ItemPublishedNotIn(vs ...time.Time) predicate.Item {
	return predicate.Item(sql.FieldNotIn(FieldItemPublished, vs...))
}

// ItemPublishedGT applies the GT predicate on the "item_published" field.
func ItemPublishedGT(v time.Time) predicate.Item {
	return predicate.Item(sql.FieldGT(FieldItemPublished, v))
}

// ItemPublishedGTE applies the GTE predicate on the "item_published" field.
func ItemPublishedGTE(v time.Time) predicate.Item {
	return predicate.Item(sql.FieldGTE(FieldItemPublished, v))
}

// ItemPublishedLT applies the LT predicate on the "item_published" field.
func ItemPublishedLT(v time.Time) predicate.Item {
	return predicate.Item(sql.FieldLT(FieldItemPublished, v))
}

// ItemPublishedLTE applies the LTE predicate on the "item_published" field.
func ItemPublishedLTE(v time.Time) predicate.Item {
	return predicate.Item(sql.FieldLTE(FieldItemPublished, v))
}

// ItemAuthorNameEQ applies the EQ predicate on the "item_author_name" field.
func ItemAuthorNameEQ(v string) predicate.Item {
	return predicate.Item(sql.FieldEQ(FieldItemAuthorName, v))
}

// ItemAuthorNameNEQ applies the NEQ predicate on the "item_author_name" field.
func ItemAuthorNameNEQ(v string) predicate.Item {
	return predicate.Item(sql.FieldNEQ(FieldItemAuthorName, v))
}

// ItemAuthorNameIn applies the In predicate on the "item_author_name" field.
func ItemAuthorNameIn(vs ...string) predicate.Item {
	return predicate.Item(sql.FieldIn(FieldItemAuthorName, vs...))
}

// ItemAuthorNameNotIn applies the NotIn predicate on the "item_author_name" field.
func ItemAuthorNameNotIn(vs ...string) predicate.Item {
	return predicate.Item(sql.FieldNotIn(FieldItemAuthorName, vs...))
}

// ItemAuthorNameGT applies the GT predicate on the "item_author_name" field.
func ItemAuthorNameGT(v string) predicate.Item {
	return predicate.Item(sql.FieldGT(FieldItemAuthorName, v))
}

// ItemAuthorNameGTE applies the GTE predicate on the "item_author_name" field.
func ItemAuthorNameGTE(v string) predicate.Item {
	return predicate.Item(sql.FieldGTE(FieldItemAuthorName, v))
}

// ItemAuthorNameLT applies the LT predicate on the "item_author_name" field.
func ItemAuthorNameLT(v string) predicate.Item {
	return predicate.Item(sql.FieldLT(FieldItemAuthorName, v))
}

// ItemAuthorNameLTE applies the LTE predicate on the "item_author_name" field.
func ItemAuthorNameLTE(v string) predicate.Item {
	return predicate.Item(sql.FieldLTE(FieldItemAuthorName, v))
}

// ItemAuthorNameContains applies the Contains predicate on the "item_author_name" field.
func ItemAuthorNameContains(v string) predicate.Item {
	return predicate.Item(sql.FieldContains(FieldItemAuthorName, v))
}

// ItemAuthorNameHasPrefix applies the HasPrefix predicate on the "item_author_name" field.
func ItemAuthorNameHasPrefix(v string) predicate.Item {
	return predicate.Item(sql.FieldHasPrefix(FieldItemAuthorName, v))
}

// ItemAuthorNameHasSuffix applies the HasSuffix predicate on the "item_author_name" field.
func ItemAuthorNameHasSuffix(v string) predicate.Item {
	return predicate.Item(sql.FieldHasSuffix(FieldItemAuthorName, v))
}

// ItemAuthorNameIsNil applies the IsNil predicate on the "item_author_name" field.
func ItemAuthorNameIsNil() predicate.Item {
	return predicate.Item(sql.FieldIsNull(FieldItemAuthorName))
}

// ItemAuthorNameNotNil applies the NotNil predicate on the "item_author_name" field.
func ItemAuthorNameNotNil() predicate.Item {
	return predicate.Item(sql.FieldNotNull(FieldItemAuthorName))
}

// ItemAuthorNameEqualFold applies the EqualFold predicate on the "item_author_name" field.
func ItemAuthorNameEqualFold(v string) predicate.Item {
	return predicate.Item(sql.FieldEqualFold(FieldItemAuthorName, v))
}

// ItemAuthorNameContainsFold applies the ContainsFold predicate on the "item_author_name" field.
func ItemAuthorNameContainsFold(v string) predicate.Item {
	return predicate.Item(sql.FieldContainsFold(FieldItemAuthorName, v))
}

// ItemAuthorEmailEQ applies the EQ predicate on the "item_author_email" field.
func ItemAuthorEmailEQ(v string) predicate.Item {
	return predicate.Item(sql.FieldEQ(FieldItemAuthorEmail, v))
}

// ItemAuthorEmailNEQ applies the NEQ predicate on the "item_author_email" field.
func ItemAuthorEmailNEQ(v string) predicate.Item {
	return predicate.Item(sql.FieldNEQ(FieldItemAuthorEmail, v))
}

// ItemAuthorEmailIn applies the In predicate on the "item_author_email" field.
func ItemAuthorEmailIn(vs ...string) predicate.Item {
	return predicate.Item(sql.FieldIn(FieldItemAuthorEmail, vs...))
}

// ItemAuthorEmailNotIn applies the NotIn predicate on the "item_author_email" field.
func ItemAuthorEmailNotIn(vs ...string) predicate.Item {
	return predicate.Item(sql.FieldNotIn(FieldItemAuthorEmail, vs...))
}

// ItemAuthorEmailGT applies the GT predicate on the "item_author_email" field.
func ItemAuthorEmailGT(v string) predicate.Item {
	return predicate.Item(sql.FieldGT(FieldItemAuthorEmail, v))
}

// ItemAuthorEmailGTE applies the GTE predicate on the "item_author_email" field.
func ItemAuthorEmailGTE(v string) predicate.Item {
	return predicate.Item(sql.FieldGTE(FieldItemAuthorEmail, v))
}

// ItemAuthorEmailLT applies the LT predicate on the "item_author_email" field.
func ItemAuthorEmailLT(v string) predicate.Item {
	return predicate.Item(sql.FieldLT(FieldItemAuthorEmail, v))
}

// ItemAuthorEmailLTE applies the LTE predicate on the "item_author_email" field.
func ItemAuthorEmailLTE(v string) predicate.Item {
	return predicate.Item(sql.FieldLTE(FieldItemAuthorEmail, v))
}

// ItemAuthorEmailContains applies the Contains predicate on the "item_author_email" field.
func ItemAuthorEmailContains(v string) predicate.Item {
	return predicate.Item(sql.FieldContains(FieldItemAuthorEmail, v))
}

// ItemAuthorEmailHasPrefix applies the HasPrefix predicate on the "item_author_email" field.
func ItemAuthorEmailHasPrefix(v string) predicate.Item {
	return predicate.Item(sql.FieldHasPrefix(FieldItemAuthorEmail, v))
}

// ItemAuthorEmailHasSuffix applies the HasSuffix predicate on the "item_author_email" field.
func ItemAuthorEmailHasSuffix(v string) predicate.Item {
	return predicate.Item(sql.FieldHasSuffix(FieldItemAuthorEmail, v))
}

// ItemAuthorEmailIsNil applies the IsNil predicate on the "item_author_email" field.
func ItemAuthorEmailIsNil() predicate.Item {
	return predicate.Item(sql.FieldIsNull(FieldItemAuthorEmail))
}

// ItemAuthorEmailNotNil applies the NotNil predicate on the "item_author_email" field.
func ItemAuthorEmailNotNil() predicate.Item {
	return predicate.Item(sql.FieldNotNull(FieldItemAuthorEmail))
}

// ItemAuthorEmailEqualFold applies the EqualFold predicate on the "item_author_email" field.
func ItemAuthorEmailEqualFold(v string) predicate.Item {
	return predicate.Item(sql.FieldEqualFold(FieldItemAuthorEmail, v))
}

// ItemAuthorEmailContainsFold applies the ContainsFold predicate on the "item_author_email" field.
func ItemAuthorEmailContainsFold(v string) predicate.Item {
	return predicate.Item(sql.FieldContainsFold(FieldItemAuthorEmail, v))
}

// ItemImageTitleEQ applies the EQ predicate on the "item_image_title" field.
func ItemImageTitleEQ(v string) predicate.Item {
	return predicate.Item(sql.FieldEQ(FieldItemImageTitle, v))
}

// ItemImageTitleNEQ applies the NEQ predicate on the "item_image_title" field.
func ItemImageTitleNEQ(v string) predicate.Item {
	return predicate.Item(sql.FieldNEQ(FieldItemImageTitle, v))
}

// ItemImageTitleIn applies the In predicate on the "item_image_title" field.
func ItemImageTitleIn(vs ...string) predicate.Item {
	return predicate.Item(sql.FieldIn(FieldItemImageTitle, vs...))
}

// ItemImageTitleNotIn applies the NotIn predicate on the "item_image_title" field.
func ItemImageTitleNotIn(vs ...string) predicate.Item {
	return predicate.Item(sql.FieldNotIn(FieldItemImageTitle, vs...))
}

// ItemImageTitleGT applies the GT predicate on the "item_image_title" field.
func ItemImageTitleGT(v string) predicate.Item {
	return predicate.Item(sql.FieldGT(FieldItemImageTitle, v))
}

// ItemImageTitleGTE applies the GTE predicate on the "item_image_title" field.
func ItemImageTitleGTE(v string) predicate.Item {
	return predicate.Item(sql.FieldGTE(FieldItemImageTitle, v))
}

// ItemImageTitleLT applies the LT predicate on the "item_image_title" field.
func ItemImageTitleLT(v string) predicate.Item {
	return predicate.Item(sql.FieldLT(FieldItemImageTitle, v))
}

// ItemImageTitleLTE applies the LTE predicate on the "item_image_title" field.
func ItemImageTitleLTE(v string) predicate.Item {
	return predicate.Item(sql.FieldLTE(FieldItemImageTitle, v))
}

// ItemImageTitleContains applies the Contains predicate on the "item_image_title" field.
func ItemImageTitleContains(v string) predicate.Item {
	return predicate.Item(sql.FieldContains(FieldItemImageTitle, v))
}

// ItemImageTitleHasPrefix applies the HasPrefix predicate on the "item_image_title" field.
func ItemImageTitleHasPrefix(v string) predicate.Item {
	return predicate.Item(sql.FieldHasPrefix(FieldItemImageTitle, v))
}

// ItemImageTitleHasSuffix applies the HasSuffix predicate on the "item_image_title" field.
func ItemImageTitleHasSuffix(v string) predicate.Item {
	return predicate.Item(sql.FieldHasSuffix(FieldItemImageTitle, v))
}

// ItemImageTitleIsNil applies the IsNil predicate on the "item_image_title" field.
func ItemImageTitleIsNil() predicate.Item {
	return predicate.Item(sql.FieldIsNull(FieldItemImageTitle))
}

// ItemImageTitleNotNil applies the NotNil predicate on the "item_image_title" field.
func ItemImageTitleNotNil() predicate.Item {
	return predicate.Item(sql.FieldNotNull(FieldItemImageTitle))
}

// ItemImageTitleEqualFold applies the EqualFold predicate on the "item_image_title" field.
func ItemImageTitleEqualFold(v string) predicate.Item {
	return predicate.Item(sql.FieldEqualFold(FieldItemImageTitle, v))
}

// ItemImageTitleContainsFold applies the ContainsFold predicate on the "item_image_title" field.
func ItemImageTitleContainsFold(v string) predicate.Item {
	return predicate.Item(sql.FieldContainsFold(FieldItemImageTitle, v))
}

// ItemImageURLEQ applies the EQ predicate on the "item_image_url" field.
func ItemImageURLEQ(v string) predicate.Item {
	return predicate.Item(sql.FieldEQ(FieldItemImageURL, v))
}

// ItemImageURLNEQ applies the NEQ predicate on the "item_image_url" field.
func ItemImageURLNEQ(v string) predicate.Item {
	return predicate.Item(sql.FieldNEQ(FieldItemImageURL, v))
}

// ItemImageURLIn applies the In predicate on the "item_image_url" field.
func ItemImageURLIn(vs ...string) predicate.Item {
	return predicate.Item(sql.FieldIn(FieldItemImageURL, vs...))
}

// ItemImageURLNotIn applies the NotIn predicate on the "item_image_url" field.
func ItemImageURLNotIn(vs ...string) predicate.Item {
	return predicate.Item(sql.FieldNotIn(FieldItemImageURL, vs...))
}

// ItemImageURLGT applies the GT predicate on the "item_image_url" field.
func ItemImageURLGT(v string) predicate.Item {
	return predicate.Item(sql.FieldGT(FieldItemImageURL, v))
}

// ItemImageURLGTE applies the GTE predicate on the "item_image_url" field.
func ItemImageURLGTE(v string) predicate.Item {
	return predicate.Item(sql.FieldGTE(FieldItemImageURL, v))
}

// ItemImageURLLT applies the LT predicate on the "item_image_url" field.
func ItemImageURLLT(v string) predicate.Item {
	return predicate.Item(sql.FieldLT(FieldItemImageURL, v))
}

// ItemImageURLLTE applies the LTE predicate on the "item_image_url" field.
func ItemImageURLLTE(v string) predicate.Item {
	return predicate.Item(sql.FieldLTE(FieldItemImageURL, v))
}

// ItemImageURLContains applies the Contains predicate on the "item_image_url" field.
func ItemImageURLContains(v string) predicate.Item {
	return predicate.Item(sql.FieldContains(FieldItemImageURL, v))
}

// ItemImageURLHasPrefix applies the HasPrefix predicate on the "item_image_url" field.
func ItemImageURLHasPrefix(v string) predicate.Item {
	return predicate.Item(sql.FieldHasPrefix(FieldItemImageURL, v))
}

// ItemImageURLHasSuffix applies the HasSuffix predicate on the "item_image_url" field.
func ItemImageURLHasSuffix(v string) predicate.Item {
	return predicate.Item(sql.FieldHasSuffix(FieldItemImageURL, v))
}

// ItemImageURLIsNil applies the IsNil predicate on the "item_image_url" field.
func ItemImageURLIsNil() predicate.Item {
	return predicate.Item(sql.FieldIsNull(FieldItemImageURL))
}

// ItemImageURLNotNil applies the NotNil predicate on the "item_image_url" field.
func ItemImageURLNotNil() predicate.Item {
	return predicate.Item(sql.FieldNotNull(FieldItemImageURL))
}

// ItemImageURLEqualFold applies the EqualFold predicate on the "item_image_url" field.
func ItemImageURLEqualFold(v string) predicate.Item {
	return predicate.Item(sql.FieldEqualFold(FieldItemImageURL, v))
}

// ItemImageURLContainsFold applies the ContainsFold predicate on the "item_image_url" field.
func ItemImageURLContainsFold(v string) predicate.Item {
	return predicate.Item(sql.FieldContainsFold(FieldItemImageURL, v))
}

// ItemCategoriesEQ applies the EQ predicate on the "item_categories" field.
func ItemCategoriesEQ(v string) predicate.Item {
	return predicate.Item(sql.FieldEQ(FieldItemCategories, v))
}

// ItemCategoriesNEQ applies the NEQ predicate on the "item_categories" field.
func ItemCategoriesNEQ(v string) predicate.Item {
	return predicate.Item(sql.FieldNEQ(FieldItemCategories, v))
}

// ItemCategoriesIn applies the In predicate on the "item_categories" field.
func ItemCategoriesIn(vs ...string) predicate.Item {
	return predicate.Item(sql.FieldIn(FieldItemCategories, vs...))
}

// ItemCategoriesNotIn applies the NotIn predicate on the "item_categories" field.
func ItemCategoriesNotIn(vs ...string) predicate.Item {
	return predicate.Item(sql.FieldNotIn(FieldItemCategories, vs...))
}

// ItemCategoriesGT applies the GT predicate on the "item_categories" field.
func ItemCategoriesGT(v string) predicate.Item {
	return predicate.Item(sql.FieldGT(FieldItemCategories, v))
}

// ItemCategoriesGTE applies the GTE predicate on the "item_categories" field.
func ItemCategoriesGTE(v string) predicate.Item {
	return predicate.Item(sql.FieldGTE(FieldItemCategories, v))
}

// ItemCategoriesLT applies the LT predicate on the "item_categories" field.
func ItemCategoriesLT(v string) predicate.Item {
	return predicate.Item(sql.FieldLT(FieldItemCategories, v))
}

// ItemCategoriesLTE applies the LTE predicate on the "item_categories" field.
func ItemCategoriesLTE(v string) predicate.Item {
	return predicate.Item(sql.FieldLTE(FieldItemCategories, v))
}

// ItemCategoriesContains applies the Contains predicate on the "item_categories" field.
func ItemCategoriesContains(v string) predicate.Item {
	return predicate.Item(sql.FieldContains(FieldItemCategories, v))
}

// ItemCategoriesHasPrefix applies the HasPrefix predicate on the "item_categories" field.
func ItemCategoriesHasPrefix(v string) predicate.Item {
	return predicate.Item(sql.FieldHasPrefix(FieldItemCategories, v))
}

// ItemCategoriesHasSuffix applies the HasSuffix predicate on the "item_categories" field.
func ItemCategoriesHasSuffix(v string) predicate.Item {
	return predicate.Item(sql.FieldHasSuffix(FieldItemCategories, v))
}

// ItemCategoriesEqualFold applies the EqualFold predicate on the "item_categories" field.
func ItemCategoriesEqualFold(v string) predicate.Item {
	return predicate.Item(sql.FieldEqualFold(FieldItemCategories, v))
}

// ItemCategoriesContainsFold applies the ContainsFold predicate on the "item_categories" field.
func ItemCategoriesContainsFold(v string) predicate.Item {
	return predicate.Item(sql.FieldContainsFold(FieldItemCategories, v))
}

// ItemEnclosuresEQ applies the EQ predicate on the "item_enclosures" field.
func ItemEnclosuresEQ(v string) predicate.Item {
	return predicate.Item(sql.FieldEQ(FieldItemEnclosures, v))
}

// ItemEnclosuresNEQ applies the NEQ predicate on the "item_enclosures" field.
func ItemEnclosuresNEQ(v string) predicate.Item {
	return predicate.Item(sql.FieldNEQ(FieldItemEnclosures, v))
}

// ItemEnclosuresIn applies the In predicate on the "item_enclosures" field.
func ItemEnclosuresIn(vs ...string) predicate.Item {
	return predicate.Item(sql.FieldIn(FieldItemEnclosures, vs...))
}

// ItemEnclosuresNotIn applies the NotIn predicate on the "item_enclosures" field.
func ItemEnclosuresNotIn(vs ...string) predicate.Item {
	return predicate.Item(sql.FieldNotIn(FieldItemEnclosures, vs...))
}

// ItemEnclosuresGT applies the GT predicate on the "item_enclosures" field.
func ItemEnclosuresGT(v string) predicate.Item {
	return predicate.Item(sql.FieldGT(FieldItemEnclosures, v))
}

// ItemEnclosuresGTE applies the GTE predicate on the "item_enclosures" field.
func ItemEnclosuresGTE(v string) predicate.Item {
	return predicate.Item(sql.FieldGTE(FieldItemEnclosures, v))
}

// ItemEnclosuresLT applies the LT predicate on the "item_enclosures" field.
func ItemEnclosuresLT(v string) predicate.Item {
	return predicate.Item(sql.FieldLT(FieldItemEnclosures, v))
}

// ItemEnclosuresLTE applies the LTE predicate on the "item_enclosures" field.
func ItemEnclosuresLTE(v string) predicate.Item {
	return predicate.Item(sql.FieldLTE(FieldItemEnclosures, v))
}

// ItemEnclosuresContains applies the Contains predicate on the "item_enclosures" field.
func ItemEnclosuresContains(v string) predicate.Item {
	return predicate.Item(sql.FieldContains(FieldItemEnclosures, v))
}

// ItemEnclosuresHasPrefix applies the HasPrefix predicate on the "item_enclosures" field.
func ItemEnclosuresHasPrefix(v string) predicate.Item {
	return predicate.Item(sql.FieldHasPrefix(FieldItemEnclosures, v))
}

// ItemEnclosuresHasSuffix applies the HasSuffix predicate on the "item_enclosures" field.
func ItemEnclosuresHasSuffix(v string) predicate.Item {
	return predicate.Item(sql.FieldHasSuffix(FieldItemEnclosures, v))
}

// ItemEnclosuresEqualFold applies the EqualFold predicate on the "item_enclosures" field.
func ItemEnclosuresEqualFold(v string) predicate.Item {
	return predicate.Item(sql.FieldEqualFold(FieldItemEnclosures, v))
}

// ItemEnclosuresContainsFold applies the ContainsFold predicate on the "item_enclosures" field.
func ItemEnclosuresContainsFold(v string) predicate.Item {
	return predicate.Item(sql.FieldContainsFold(FieldItemEnclosures, v))
}

// CrawlerTitleEQ applies the EQ predicate on the "crawler_title" field.
func CrawlerTitleEQ(v string) predicate.Item {
	return predicate.Item(sql.FieldEQ(FieldCrawlerTitle, v))
}

// CrawlerTitleNEQ applies the NEQ predicate on the "crawler_title" field.
func CrawlerTitleNEQ(v string) predicate.Item {
	return predicate.Item(sql.FieldNEQ(FieldCrawlerTitle, v))
}

// CrawlerTitleIn applies the In predicate on the "crawler_title" field.
func CrawlerTitleIn(vs ...string) predicate.Item {
	return predicate.Item(sql.FieldIn(FieldCrawlerTitle, vs...))
}

// CrawlerTitleNotIn applies the NotIn predicate on the "crawler_title" field.
func CrawlerTitleNotIn(vs ...string) predicate.Item {
	return predicate.Item(sql.FieldNotIn(FieldCrawlerTitle, vs...))
}

// CrawlerTitleGT applies the GT predicate on the "crawler_title" field.
func CrawlerTitleGT(v string) predicate.Item {
	return predicate.Item(sql.FieldGT(FieldCrawlerTitle, v))
}

// CrawlerTitleGTE applies the GTE predicate on the "crawler_title" field.
func CrawlerTitleGTE(v string) predicate.Item {
	return predicate.Item(sql.FieldGTE(FieldCrawlerTitle, v))
}

// CrawlerTitleLT applies the LT predicate on the "crawler_title" field.
func CrawlerTitleLT(v string) predicate.Item {
	return predicate.Item(sql.FieldLT(FieldCrawlerTitle, v))
}

// CrawlerTitleLTE applies the LTE predicate on the "crawler_title" field.
func CrawlerTitleLTE(v string) predicate.Item {
	return predicate.Item(sql.FieldLTE(FieldCrawlerTitle, v))
}

// CrawlerTitleContains applies the Contains predicate on the "crawler_title" field.
func CrawlerTitleContains(v string) predicate.Item {
	return predicate.Item(sql.FieldContains(FieldCrawlerTitle, v))
}

// CrawlerTitleHasPrefix applies the HasPrefix predicate on the "crawler_title" field.
func CrawlerTitleHasPrefix(v string) predicate.Item {
	return predicate.Item(sql.FieldHasPrefix(FieldCrawlerTitle, v))
}

// CrawlerTitleHasSuffix applies the HasSuffix predicate on the "crawler_title" field.
func CrawlerTitleHasSuffix(v string) predicate.Item {
	return predicate.Item(sql.FieldHasSuffix(FieldCrawlerTitle, v))
}

// CrawlerTitleIsNil applies the IsNil predicate on the "crawler_title" field.
func CrawlerTitleIsNil() predicate.Item {
	return predicate.Item(sql.FieldIsNull(FieldCrawlerTitle))
}

// CrawlerTitleNotNil applies the NotNil predicate on the "crawler_title" field.
func CrawlerTitleNotNil() predicate.Item {
	return predicate.Item(sql.FieldNotNull(FieldCrawlerTitle))
}

// CrawlerTitleEqualFold applies the EqualFold predicate on the "crawler_title" field.
func CrawlerTitleEqualFold(v string) predicate.Item {
	return predicate.Item(sql.FieldEqualFold(FieldCrawlerTitle, v))
}

// CrawlerTitleContainsFold applies the ContainsFold predicate on the "crawler_title" field.
func CrawlerTitleContainsFold(v string) predicate.Item {
	return predicate.Item(sql.FieldContainsFold(FieldCrawlerTitle, v))
}

// CrawlerAuthorEQ applies the EQ predicate on the "crawler_author" field.
func CrawlerAuthorEQ(v string) predicate.Item {
	return predicate.Item(sql.FieldEQ(FieldCrawlerAuthor, v))
}

// CrawlerAuthorNEQ applies the NEQ predicate on the "crawler_author" field.
func CrawlerAuthorNEQ(v string) predicate.Item {
	return predicate.Item(sql.FieldNEQ(FieldCrawlerAuthor, v))
}

// CrawlerAuthorIn applies the In predicate on the "crawler_author" field.
func CrawlerAuthorIn(vs ...string) predicate.Item {
	return predicate.Item(sql.FieldIn(FieldCrawlerAuthor, vs...))
}

// CrawlerAuthorNotIn applies the NotIn predicate on the "crawler_author" field.
func CrawlerAuthorNotIn(vs ...string) predicate.Item {
	return predicate.Item(sql.FieldNotIn(FieldCrawlerAuthor, vs...))
}

// CrawlerAuthorGT applies the GT predicate on the "crawler_author" field.
func CrawlerAuthorGT(v string) predicate.Item {
	return predicate.Item(sql.FieldGT(FieldCrawlerAuthor, v))
}

// CrawlerAuthorGTE applies the GTE predicate on the "crawler_author" field.
func CrawlerAuthorGTE(v string) predicate.Item {
	return predicate.Item(sql.FieldGTE(FieldCrawlerAuthor, v))
}

// CrawlerAuthorLT applies the LT predicate on the "crawler_author" field.
func CrawlerAuthorLT(v string) predicate.Item {
	return predicate.Item(sql.FieldLT(FieldCrawlerAuthor, v))
}

// CrawlerAuthorLTE applies the LTE predicate on the "crawler_author" field.
func CrawlerAuthorLTE(v string) predicate.Item {
	return predicate.Item(sql.FieldLTE(FieldCrawlerAuthor, v))
}

// CrawlerAuthorContains applies the Contains predicate on the "crawler_author" field.
func CrawlerAuthorContains(v string) predicate.Item {
	return predicate.Item(sql.FieldContains(FieldCrawlerAuthor, v))
}

// CrawlerAuthorHasPrefix applies the HasPrefix predicate on the "crawler_author" field.
func CrawlerAuthorHasPrefix(v string) predicate.Item {
	return predicate.Item(sql.FieldHasPrefix(FieldCrawlerAuthor, v))
}

// CrawlerAuthorHasSuffix applies the HasSuffix predicate on the "crawler_author" field.
func CrawlerAuthorHasSuffix(v string) predicate.Item {
	return predicate.Item(sql.FieldHasSuffix(FieldCrawlerAuthor, v))
}

// CrawlerAuthorIsNil applies the IsNil predicate on the "crawler_author" field.
func CrawlerAuthorIsNil() predicate.Item {
	return predicate.Item(sql.FieldIsNull(FieldCrawlerAuthor))
}

// CrawlerAuthorNotNil applies the NotNil predicate on the "crawler_author" field.
func CrawlerAuthorNotNil() predicate.Item {
	return predicate.Item(sql.FieldNotNull(FieldCrawlerAuthor))
}

// CrawlerAuthorEqualFold applies the EqualFold predicate on the "crawler_author" field.
func CrawlerAuthorEqualFold(v string) predicate.Item {
	return predicate.Item(sql.FieldEqualFold(FieldCrawlerAuthor, v))
}

// CrawlerAuthorContainsFold applies the ContainsFold predicate on the "crawler_author" field.
func CrawlerAuthorContainsFold(v string) predicate.Item {
	return predicate.Item(sql.FieldContainsFold(FieldCrawlerAuthor, v))
}

// CrawlerExcerptEQ applies the EQ predicate on the "crawler_excerpt" field.
func CrawlerExcerptEQ(v string) predicate.Item {
	return predicate.Item(sql.FieldEQ(FieldCrawlerExcerpt, v))
}

// CrawlerExcerptNEQ applies the NEQ predicate on the "crawler_excerpt" field.
func CrawlerExcerptNEQ(v string) predicate.Item {
	return predicate.Item(sql.FieldNEQ(FieldCrawlerExcerpt, v))
}

// CrawlerExcerptIn applies the In predicate on the "crawler_excerpt" field.
func CrawlerExcerptIn(vs ...string) predicate.Item {
	return predicate.Item(sql.FieldIn(FieldCrawlerExcerpt, vs...))
}

// CrawlerExcerptNotIn applies the NotIn predicate on the "crawler_excerpt" field.
func CrawlerExcerptNotIn(vs ...string) predicate.Item {
	return predicate.Item(sql.FieldNotIn(FieldCrawlerExcerpt, vs...))
}

// CrawlerExcerptGT applies the GT predicate on the "crawler_excerpt" field.
func CrawlerExcerptGT(v string) predicate.Item {
	return predicate.Item(sql.FieldGT(FieldCrawlerExcerpt, v))
}

// CrawlerExcerptGTE applies the GTE predicate on the "crawler_excerpt" field.
func CrawlerExcerptGTE(v string) predicate.Item {
	return predicate.Item(sql.FieldGTE(FieldCrawlerExcerpt, v))
}

// CrawlerExcerptLT applies the LT predicate on the "crawler_excerpt" field.
func CrawlerExcerptLT(v string) predicate.Item {
	return predicate.Item(sql.FieldLT(FieldCrawlerExcerpt, v))
}

// CrawlerExcerptLTE applies the LTE predicate on the "crawler_excerpt" field.
func CrawlerExcerptLTE(v string) predicate.Item {
	return predicate.Item(sql.FieldLTE(FieldCrawlerExcerpt, v))
}

// CrawlerExcerptContains applies the Contains predicate on the "crawler_excerpt" field.
func CrawlerExcerptContains(v string) predicate.Item {
	return predicate.Item(sql.FieldContains(FieldCrawlerExcerpt, v))
}

// CrawlerExcerptHasPrefix applies the HasPrefix predicate on the "crawler_excerpt" field.
func CrawlerExcerptHasPrefix(v string) predicate.Item {
	return predicate.Item(sql.FieldHasPrefix(FieldCrawlerExcerpt, v))
}

// CrawlerExcerptHasSuffix applies the HasSuffix predicate on the "crawler_excerpt" field.
func CrawlerExcerptHasSuffix(v string) predicate.Item {
	return predicate.Item(sql.FieldHasSuffix(FieldCrawlerExcerpt, v))
}

// CrawlerExcerptIsNil applies the IsNil predicate on the "crawler_excerpt" field.
func CrawlerExcerptIsNil() predicate.Item {
	return predicate.Item(sql.FieldIsNull(FieldCrawlerExcerpt))
}

// CrawlerExcerptNotNil applies the NotNil predicate on the "crawler_excerpt" field.
func CrawlerExcerptNotNil() predicate.Item {
	return predicate.Item(sql.FieldNotNull(FieldCrawlerExcerpt))
}

// CrawlerExcerptEqualFold applies the EqualFold predicate on the "crawler_excerpt" field.
func CrawlerExcerptEqualFold(v string) predicate.Item {
	return predicate.Item(sql.FieldEqualFold(FieldCrawlerExcerpt, v))
}

// CrawlerExcerptContainsFold applies the ContainsFold predicate on the "crawler_excerpt" field.
func CrawlerExcerptContainsFold(v string) predicate.Item {
	return predicate.Item(sql.FieldContainsFold(FieldCrawlerExcerpt, v))
}

// CrawlerSiteNameEQ applies the EQ predicate on the "crawler_site_name" field.
func CrawlerSiteNameEQ(v string) predicate.Item {
	return predicate.Item(sql.FieldEQ(FieldCrawlerSiteName, v))
}

// CrawlerSiteNameNEQ applies the NEQ predicate on the "crawler_site_name" field.
func CrawlerSiteNameNEQ(v string) predicate.Item {
	return predicate.Item(sql.FieldNEQ(FieldCrawlerSiteName, v))
}

// CrawlerSiteNameIn applies the In predicate on the "crawler_site_name" field.
func CrawlerSiteNameIn(vs ...string) predicate.Item {
	return predicate.Item(sql.FieldIn(FieldCrawlerSiteName, vs...))
}

// CrawlerSiteNameNotIn applies the NotIn predicate on the "crawler_site_name" field.
func CrawlerSiteNameNotIn(vs ...string) predicate.Item {
	return predicate.Item(sql.FieldNotIn(FieldCrawlerSiteName, vs...))
}

// CrawlerSiteNameGT applies the GT predicate on the "crawler_site_name" field.
func CrawlerSiteNameGT(v string) predicate.Item {
	return predicate.Item(sql.FieldGT(FieldCrawlerSiteName, v))
}

// CrawlerSiteNameGTE applies the GTE predicate on the "crawler_site_name" field.
func CrawlerSiteNameGTE(v string) predicate.Item {
	return predicate.Item(sql.FieldGTE(FieldCrawlerSiteName, v))
}

// CrawlerSiteNameLT applies the LT predicate on the "crawler_site_name" field.
func CrawlerSiteNameLT(v string) predicate.Item {
	return predicate.Item(sql.FieldLT(FieldCrawlerSiteName, v))
}

// CrawlerSiteNameLTE applies the LTE predicate on the "crawler_site_name" field.
func CrawlerSiteNameLTE(v string) predicate.Item {
	return predicate.Item(sql.FieldLTE(FieldCrawlerSiteName, v))
}

// CrawlerSiteNameContains applies the Contains predicate on the "crawler_site_name" field.
func CrawlerSiteNameContains(v string) predicate.Item {
	return predicate.Item(sql.FieldContains(FieldCrawlerSiteName, v))
}

// CrawlerSiteNameHasPrefix applies the HasPrefix predicate on the "crawler_site_name" field.
func CrawlerSiteNameHasPrefix(v string) predicate.Item {
	return predicate.Item(sql.FieldHasPrefix(FieldCrawlerSiteName, v))
}

// CrawlerSiteNameHasSuffix applies the HasSuffix predicate on the "crawler_site_name" field.
func CrawlerSiteNameHasSuffix(v string) predicate.Item {
	return predicate.Item(sql.FieldHasSuffix(FieldCrawlerSiteName, v))
}

// CrawlerSiteNameIsNil applies the IsNil predicate on the "crawler_site_name" field.
func CrawlerSiteNameIsNil() predicate.Item {
	return predicate.Item(sql.FieldIsNull(FieldCrawlerSiteName))
}

// CrawlerSiteNameNotNil applies the NotNil predicate on the "crawler_site_name" field.
func CrawlerSiteNameNotNil() predicate.Item {
	return predicate.Item(sql.FieldNotNull(FieldCrawlerSiteName))
}

// CrawlerSiteNameEqualFold applies the EqualFold predicate on the "crawler_site_name" field.
func CrawlerSiteNameEqualFold(v string) predicate.Item {
	return predicate.Item(sql.FieldEqualFold(FieldCrawlerSiteName, v))
}

// CrawlerSiteNameContainsFold applies the ContainsFold predicate on the "crawler_site_name" field.
func CrawlerSiteNameContainsFold(v string) predicate.Item {
	return predicate.Item(sql.FieldContainsFold(FieldCrawlerSiteName, v))
}

// CrawlerImageEQ applies the EQ predicate on the "crawler_image" field.
func CrawlerImageEQ(v string) predicate.Item {
	return predicate.Item(sql.FieldEQ(FieldCrawlerImage, v))
}

// CrawlerImageNEQ applies the NEQ predicate on the "crawler_image" field.
func CrawlerImageNEQ(v string) predicate.Item {
	return predicate.Item(sql.FieldNEQ(FieldCrawlerImage, v))
}

// CrawlerImageIn applies the In predicate on the "crawler_image" field.
func CrawlerImageIn(vs ...string) predicate.Item {
	return predicate.Item(sql.FieldIn(FieldCrawlerImage, vs...))
}

// CrawlerImageNotIn applies the NotIn predicate on the "crawler_image" field.
func CrawlerImageNotIn(vs ...string) predicate.Item {
	return predicate.Item(sql.FieldNotIn(FieldCrawlerImage, vs...))
}

// CrawlerImageGT applies the GT predicate on the "crawler_image" field.
func CrawlerImageGT(v string) predicate.Item {
	return predicate.Item(sql.FieldGT(FieldCrawlerImage, v))
}

// CrawlerImageGTE applies the GTE predicate on the "crawler_image" field.
func CrawlerImageGTE(v string) predicate.Item {
	return predicate.Item(sql.FieldGTE(FieldCrawlerImage, v))
}

// CrawlerImageLT applies the LT predicate on the "crawler_image" field.
func CrawlerImageLT(v string) predicate.Item {
	return predicate.Item(sql.FieldLT(FieldCrawlerImage, v))
}

// CrawlerImageLTE applies the LTE predicate on the "crawler_image" field.
func CrawlerImageLTE(v string) predicate.Item {
	return predicate.Item(sql.FieldLTE(FieldCrawlerImage, v))
}

// CrawlerImageContains applies the Contains predicate on the "crawler_image" field.
func CrawlerImageContains(v string) predicate.Item {
	return predicate.Item(sql.FieldContains(FieldCrawlerImage, v))
}

// CrawlerImageHasPrefix applies the HasPrefix predicate on the "crawler_image" field.
func CrawlerImageHasPrefix(v string) predicate.Item {
	return predicate.Item(sql.FieldHasPrefix(FieldCrawlerImage, v))
}

// CrawlerImageHasSuffix applies the HasSuffix predicate on the "crawler_image" field.
func CrawlerImageHasSuffix(v string) predicate.Item {
	return predicate.Item(sql.FieldHasSuffix(FieldCrawlerImage, v))
}

// CrawlerImageIsNil applies the IsNil predicate on the "crawler_image" field.
func CrawlerImageIsNil() predicate.Item {
	return predicate.Item(sql.FieldIsNull(FieldCrawlerImage))
}

// CrawlerImageNotNil applies the NotNil predicate on the "crawler_image" field.
func CrawlerImageNotNil() predicate.Item {
	return predicate.Item(sql.FieldNotNull(FieldCrawlerImage))
}

// CrawlerImageEqualFold applies the EqualFold predicate on the "crawler_image" field.
func CrawlerImageEqualFold(v string) predicate.Item {
	return predicate.Item(sql.FieldEqualFold(FieldCrawlerImage, v))
}

// CrawlerImageContainsFold applies the ContainsFold predicate on the "crawler_image" field.
func CrawlerImageContainsFold(v string) predicate.Item {
	return predicate.Item(sql.FieldContainsFold(FieldCrawlerImage, v))
}

// CrawlerContentHTMLEQ applies the EQ predicate on the "crawler_content_html" field.
func CrawlerContentHTMLEQ(v string) predicate.Item {
	return predicate.Item(sql.FieldEQ(FieldCrawlerContentHTML, v))
}

// CrawlerContentHTMLNEQ applies the NEQ predicate on the "crawler_content_html" field.
func CrawlerContentHTMLNEQ(v string) predicate.Item {
	return predicate.Item(sql.FieldNEQ(FieldCrawlerContentHTML, v))
}

// CrawlerContentHTMLIn applies the In predicate on the "crawler_content_html" field.
func CrawlerContentHTMLIn(vs ...string) predicate.Item {
	return predicate.Item(sql.FieldIn(FieldCrawlerContentHTML, vs...))
}

// CrawlerContentHTMLNotIn applies the NotIn predicate on the "crawler_content_html" field.
func CrawlerContentHTMLNotIn(vs ...string) predicate.Item {
	return predicate.Item(sql.FieldNotIn(FieldCrawlerContentHTML, vs...))
}

// CrawlerContentHTMLGT applies the GT predicate on the "crawler_content_html" field.
func CrawlerContentHTMLGT(v string) predicate.Item {
	return predicate.Item(sql.FieldGT(FieldCrawlerContentHTML, v))
}

// CrawlerContentHTMLGTE applies the GTE predicate on the "crawler_content_html" field.
func CrawlerContentHTMLGTE(v string) predicate.Item {
	return predicate.Item(sql.FieldGTE(FieldCrawlerContentHTML, v))
}

// CrawlerContentHTMLLT applies the LT predicate on the "crawler_content_html" field.
func CrawlerContentHTMLLT(v string) predicate.Item {
	return predicate.Item(sql.FieldLT(FieldCrawlerContentHTML, v))
}

// CrawlerContentHTMLLTE applies the LTE predicate on the "crawler_content_html" field.
func CrawlerContentHTMLLTE(v string) predicate.Item {
	return predicate.Item(sql.FieldLTE(FieldCrawlerContentHTML, v))
}

// CrawlerContentHTMLContains applies the Contains predicate on the "crawler_content_html" field.
func CrawlerContentHTMLContains(v string) predicate.Item {
	return predicate.Item(sql.FieldContains(FieldCrawlerContentHTML, v))
}

// CrawlerContentHTMLHasPrefix applies the HasPrefix predicate on the "crawler_content_html" field.
func CrawlerContentHTMLHasPrefix(v string) predicate.Item {
	return predicate.Item(sql.FieldHasPrefix(FieldCrawlerContentHTML, v))
}

// CrawlerContentHTMLHasSuffix applies the HasSuffix predicate on the "crawler_content_html" field.
func CrawlerContentHTMLHasSuffix(v string) predicate.Item {
	return predicate.Item(sql.FieldHasSuffix(FieldCrawlerContentHTML, v))
}

// CrawlerContentHTMLIsNil applies the IsNil predicate on the "crawler_content_html" field.
func CrawlerContentHTMLIsNil() predicate.Item {
	return predicate.Item(sql.FieldIsNull(FieldCrawlerContentHTML))
}

// CrawlerContentHTMLNotNil applies the NotNil predicate on the "crawler_content_html" field.
func CrawlerContentHTMLNotNil() predicate.Item {
	return predicate.Item(sql.FieldNotNull(FieldCrawlerContentHTML))
}

// CrawlerContentHTMLEqualFold applies the EqualFold predicate on the "crawler_content_html" field.
func CrawlerContentHTMLEqualFold(v string) predicate.Item {
	return predicate.Item(sql.FieldEqualFold(FieldCrawlerContentHTML, v))
}

// CrawlerContentHTMLContainsFold applies the ContainsFold predicate on the "crawler_content_html" field.
func CrawlerContentHTMLContainsFold(v string) predicate.Item {
	return predicate.Item(sql.FieldContainsFold(FieldCrawlerContentHTML, v))
}

// CrawlerContentTextEQ applies the EQ predicate on the "crawler_content_text" field.
func CrawlerContentTextEQ(v string) predicate.Item {
	return predicate.Item(sql.FieldEQ(FieldCrawlerContentText, v))
}

// CrawlerContentTextNEQ applies the NEQ predicate on the "crawler_content_text" field.
func CrawlerContentTextNEQ(v string) predicate.Item {
	return predicate.Item(sql.FieldNEQ(FieldCrawlerContentText, v))
}

// CrawlerContentTextIn applies the In predicate on the "crawler_content_text" field.
func CrawlerContentTextIn(vs ...string) predicate.Item {
	return predicate.Item(sql.FieldIn(FieldCrawlerContentText, vs...))
}

// CrawlerContentTextNotIn applies the NotIn predicate on the "crawler_content_text" field.
func CrawlerContentTextNotIn(vs ...string) predicate.Item {
	return predicate.Item(sql.FieldNotIn(FieldCrawlerContentText, vs...))
}

// CrawlerContentTextGT applies the GT predicate on the "crawler_content_text" field.
func CrawlerContentTextGT(v string) predicate.Item {
	return predicate.Item(sql.FieldGT(FieldCrawlerContentText, v))
}

// CrawlerContentTextGTE applies the GTE predicate on the "crawler_content_text" field.
func CrawlerContentTextGTE(v string) predicate.Item {
	return predicate.Item(sql.FieldGTE(FieldCrawlerContentText, v))
}

// CrawlerContentTextLT applies the LT predicate on the "crawler_content_text" field.
func CrawlerContentTextLT(v string) predicate.Item {
	return predicate.Item(sql.FieldLT(FieldCrawlerContentText, v))
}

// CrawlerContentTextLTE applies the LTE predicate on the "crawler_content_text" field.
func CrawlerContentTextLTE(v string) predicate.Item {
	return predicate.Item(sql.FieldLTE(FieldCrawlerContentText, v))
}

// CrawlerContentTextContains applies the Contains predicate on the "crawler_content_text" field.
func CrawlerContentTextContains(v string) predicate.Item {
	return predicate.Item(sql.FieldContains(FieldCrawlerContentText, v))
}

// CrawlerContentTextHasPrefix applies the HasPrefix predicate on the "crawler_content_text" field.
func CrawlerContentTextHasPrefix(v string) predicate.Item {
	return predicate.Item(sql.FieldHasPrefix(FieldCrawlerContentText, v))
}

// CrawlerContentTextHasSuffix applies the HasSuffix predicate on the "crawler_content_text" field.
func CrawlerContentTextHasSuffix(v string) predicate.Item {
	return predicate.Item(sql.FieldHasSuffix(FieldCrawlerContentText, v))
}

// CrawlerContentTextIsNil applies the IsNil predicate on the "crawler_content_text" field.
func CrawlerContentTextIsNil() predicate.Item {
	return predicate.Item(sql.FieldIsNull(FieldCrawlerContentText))
}

// CrawlerContentTextNotNil applies the NotNil predicate on the "crawler_content_text" field.
func CrawlerContentTextNotNil() predicate.Item {
	return predicate.Item(sql.FieldNotNull(FieldCrawlerContentText))
}

// CrawlerContentTextEqualFold applies the EqualFold predicate on the "crawler_content_text" field.
func CrawlerContentTextEqualFold(v string) predicate.Item {
	return predicate.Item(sql.FieldEqualFold(FieldCrawlerContentText, v))
}

// CrawlerContentTextContainsFold applies the ContainsFold predicate on the "crawler_content_text" field.
func CrawlerContentTextContainsFold(v string) predicate.Item {
	return predicate.Item(sql.FieldContainsFold(FieldCrawlerContentText, v))
}

// CreatedAtEQ applies the EQ predicate on the "created_at" field.
func CreatedAtEQ(v time.Time) predicate.Item {
	return predicate.Item(sql.FieldEQ(FieldCreatedAt, v))
}

// CreatedAtNEQ applies the NEQ predicate on the "created_at" field.
func CreatedAtNEQ(v time.Time) predicate.Item {
	return predicate.Item(sql.FieldNEQ(FieldCreatedAt, v))
}

// CreatedAtIn applies the In predicate on the "created_at" field.
func CreatedAtIn(vs ...time.Time) predicate.Item {
	return predicate.Item(sql.FieldIn(FieldCreatedAt, vs...))
}

// CreatedAtNotIn applies the NotIn predicate on the "created_at" field.
func CreatedAtNotIn(vs ...time.Time) predicate.Item {
	return predicate.Item(sql.FieldNotIn(FieldCreatedAt, vs...))
}

// CreatedAtGT applies the GT predicate on the "created_at" field.
func CreatedAtGT(v time.Time) predicate.Item {
	return predicate.Item(sql.FieldGT(FieldCreatedAt, v))
}

// CreatedAtGTE applies the GTE predicate on the "created_at" field.
func CreatedAtGTE(v time.Time) predicate.Item {
	return predicate.Item(sql.FieldGTE(FieldCreatedAt, v))
}

// CreatedAtLT applies the LT predicate on the "created_at" field.
func CreatedAtLT(v time.Time) predicate.Item {
	return predicate.Item(sql.FieldLT(FieldCreatedAt, v))
}

// CreatedAtLTE applies the LTE predicate on the "created_at" field.
func CreatedAtLTE(v time.Time) predicate.Item {
	return predicate.Item(sql.FieldLTE(FieldCreatedAt, v))
}

// UpdatedAtEQ applies the EQ predicate on the "updated_at" field.
func UpdatedAtEQ(v time.Time) predicate.Item {
	return predicate.Item(sql.FieldEQ(FieldUpdatedAt, v))
}

// UpdatedAtNEQ applies the NEQ predicate on the "updated_at" field.
func UpdatedAtNEQ(v time.Time) predicate.Item {
	return predicate.Item(sql.FieldNEQ(FieldUpdatedAt, v))
}

// UpdatedAtIn applies the In predicate on the "updated_at" field.
func UpdatedAtIn(vs ...time.Time) predicate.Item {
	return predicate.Item(sql.FieldIn(FieldUpdatedAt, vs...))
}

// UpdatedAtNotIn applies the NotIn predicate on the "updated_at" field.
func UpdatedAtNotIn(vs ...time.Time) predicate.Item {
	return predicate.Item(sql.FieldNotIn(FieldUpdatedAt, vs...))
}

// UpdatedAtGT applies the GT predicate on the "updated_at" field.
func UpdatedAtGT(v time.Time) predicate.Item {
	return predicate.Item(sql.FieldGT(FieldUpdatedAt, v))
}

// UpdatedAtGTE applies the GTE predicate on the "updated_at" field.
func UpdatedAtGTE(v time.Time) predicate.Item {
	return predicate.Item(sql.FieldGTE(FieldUpdatedAt, v))
}

// UpdatedAtLT applies the LT predicate on the "updated_at" field.
func UpdatedAtLT(v time.Time) predicate.Item {
	return predicate.Item(sql.FieldLT(FieldUpdatedAt, v))
}

// UpdatedAtLTE applies the LTE predicate on the "updated_at" field.
func UpdatedAtLTE(v time.Time) predicate.Item {
	return predicate.Item(sql.FieldLTE(FieldUpdatedAt, v))
}

// HasFeed applies the HasEdge predicate on the "feed" edge.
func HasFeed() predicate.Item {
	return predicate.Item(func(s *sql.Selector) {
		step := sqlgraph.NewStep(
			sqlgraph.From(Table, FieldID),
			sqlgraph.Edge(sqlgraph.M2O, true, FeedTable, FeedColumn),
		)
		sqlgraph.HasNeighbors(s, step)
	})
}

// HasFeedWith applies the HasEdge predicate on the "feed" edge with a given conditions (other predicates).
func HasFeedWith(preds ...predicate.Feed) predicate.Item {
	return predicate.Item(func(s *sql.Selector) {
		step := newFeedStep()
		sqlgraph.HasNeighborsWith(s, step, func(s *sql.Selector) {
			for _, p := range preds {
				p(s)
			}
		})
	})
}

// HasReadByUsers applies the HasEdge predicate on the "read_by_users" edge.
func HasReadByUsers() predicate.Item {
	return predicate.Item(func(s *sql.Selector) {
		step := sqlgraph.NewStep(
			sqlgraph.From(Table, FieldID),
			sqlgraph.Edge(sqlgraph.M2M, true, ReadByUsersTable, ReadByUsersPrimaryKey...),
		)
		sqlgraph.HasNeighbors(s, step)
	})
}

// HasReadByUsersWith applies the HasEdge predicate on the "read_by_users" edge with a given conditions (other predicates).
func HasReadByUsersWith(preds ...predicate.User) predicate.Item {
	return predicate.Item(func(s *sql.Selector) {
		step := newReadByUsersStep()
		sqlgraph.HasNeighborsWith(s, step, func(s *sql.Selector) {
			for _, p := range preds {
				p(s)
			}
		})
	})
}

// HasReads applies the HasEdge predicate on the "reads" edge.
func HasReads() predicate.Item {
	return predicate.Item(func(s *sql.Selector) {
		step := sqlgraph.NewStep(
			sqlgraph.From(Table, FieldID),
			sqlgraph.Edge(sqlgraph.O2M, true, ReadsTable, ReadsColumn),
		)
		sqlgraph.HasNeighbors(s, step)
	})
}

// HasReadsWith applies the HasEdge predicate on the "reads" edge with a given conditions (other predicates).
func HasReadsWith(preds ...predicate.Read) predicate.Item {
	return predicate.Item(func(s *sql.Selector) {
		step := newReadsStep()
		sqlgraph.HasNeighborsWith(s, step, func(s *sql.Selector) {
			for _, p := range preds {
				p(s)
			}
		})
	})
}

// And groups predicates with the AND operator between them.
func And(predicates ...predicate.Item) predicate.Item {
	return predicate.Item(sql.AndPredicates(predicates...))
}

// Or groups predicates with the OR operator between them.
func Or(predicates ...predicate.Item) predicate.Item {
	return predicate.Item(sql.OrPredicates(predicates...))
}

// Not applies the not operator on the given predicate.
func Not(p predicate.Item) predicate.Item {
	return predicate.Item(sql.NotPredicates(p))
}
